//+------------------------------------------------------------------+
//|                                                     EA_HAshi.mq4 |
//+------------------------------------------------------------------+

#property copyright "Donny and Radicatour"
#property link      ""

extern string EA ="****** EA Setup ******";
extern int MagicNumber = 12345;
extern string MM ="****** Money Management ******";
extern double Lots = 0.1;
extern double StopLoss =200;
extern double TakeProfit=200;

extern string ExitCriteria ="****** Entry Criteria for Kijun ******";
extern bool UseKijenSenForExit = true;
extern int KijenSenValueForExit = 24;
extern bool UseDynamic1ForExit = true;

extern string EntryCriteria1 ="****** Entry Criteria for Kijun ******";
extern bool UseKijenSenForEntry = true;
extern int KijenSenValueForEntry = 24;

string EntryCriteria2 ="****** Entry Criteria for Heiken ******";
bool UseHeikenCandleClosed = true;
extern int Heiken_MAPeriod = 1;
extern int Heiken_MAMethod = 1;
extern int Heiken_Step = 0;
extern int Heiken_CountBars = 4000;
extern bool Heiken_UseT3 = true;
extern double Heiken_b = 0.88;


extern string EntryCriteria3 ="****** Entry Criteria for Dynamic ******";
extern bool UseDynamic1 = true;
extern int Dynamic_MAPeriod = 3;
extern int Dynamic_MAMethod = 2;
extern int Dynamic_UseSignal = 0;

extern string EntryCriteria4 ="****** Entry Criteria for BBand Stop ******";
extern bool UseBBandStop = false;
extern int BBand_Length = 6;
extern int BBand_Deviation = 2;
extern double BBand_MoneyRisk = 1.0;
extern int BBand_Signal = 1;
extern int BBand_Line = 1;
extern int BBand_NBars = 1000;

extern string EntryCriteria5 ="****** Entry Criteria for CTI ******";

extern bool UseCTI_1 = true;
extern int CTI_TimeFrame1 = 30;
extern bool UseCTI_2 = false;
extern int CTI_TimeFrame2 = 60;
bool UseCTI_3 = false;
int CTI_TimeFrame3 = 240;

extern string TS ="****** Trailing Setup ******";
extern int TrailingProfit=0;//|------------------trailing stop after profit reached
extern int TrailingStop=0;//|--------------------trailing stop
extern int TrailingStep=0;//|--------------------trailing step

//bool TrailingOn = false;
//double TrailingStop =5;
//double TrailingStep=1;
extern string BE ="****** Break Even ******";
extern int BreakEvenAt = 50; //breakeven
//extern bool BreakEvenOn = false;
//extern double BreakEvenStop = 5;
//extern double BreakEvenStep = 1;


extern string TF = "****** Time Filters ******";
extern bool UseTimeFilter=false; 
extern int GMTOffset = 0;
extern int StartDay = 0;
extern int EndDay = 5;
extern int StartHour = 7;
extern int EndHour = 17;


string NF = "--------------News Filters--------------";
bool UseNewsFilter = false;
int MinutesBeforeNews = 60;
int MinutesAfterNews = 60;
bool IncludeHigh = TRUE;
bool IncludeMedium = false;
bool IncludeLow = FALSE;
bool IncludeSpeaks = TRUE;
int      time[5];
int      news1;
int      news2;


double point;
int digits;
int bars;

string 
      Message,
      Message1,
      Message2;
      
bool 
      LongActive=false,
      ShortActive=false,
      BreakEvenLongActive =false,
      BreakEvenShortActive =false;
      
datetime CandleOpenTime, NextOpenTime;
double   
      BreakEvenLongPrice,
      BreakEvenShortPrice;      

//----------------------------------------------------------------------
int init()
  {
      if (Digits < 4)
      {
         point = 0.01;
         digits = 2;
      }
      else
      {
         point = 0.0001;
         digits = 4;
      }
      
      bars = 0;
      
      return(0);
  }
  
  
int start()
  {

    if (CandleOpenTime != Time[0])
    {
         f_PrintEAInfo();
      
         double signalHAshiCurrentBarUp, signalHAshiPreviousBarUp, signalHAshi2BarsAgoUp, signalHAshiCurrentBarDown, signalHAshiPreviousBarDown, signalHAshi2BarsAgoDown;
         double kijunSenPreviousBarEntry, kijunSenPreviousBarExit;
         double previousPriceClose, priceClose2BarsAgo;
         double dgainUp, dgainDown, dgainArrowUp, dgainArrowDown;
         double bbandStopUp, bbandStopDown, bbandUpTrendLine, bbandDownTrendLine;
         int ctiSignal = 0;
         int totalBuyOrders = 0, totalSellOrders = 0, totalOrders = 0;
         //bool maxBuyOrdersReached = false, maxSellOrdersReached = false, buyMartingaleInAffect = false, sellMartingaleInAffect = false;
         double largestBuyLotSize = 0, largestSellLotSize = 0, lastBuyPrice = 0, lastSellPrice;
      
         GetOrderTotals(totalBuyOrders, totalSellOrders, largestBuyLotSize, largestSellLotSize, lastBuyPrice, lastSellPrice);  
         totalOrders = totalBuyOrders + totalSellOrders;
         
         //signalHAshiCurrentBarDown = SignalHAshi(2,0);
         signalHAshiPreviousBarDown = SignalHAshi(2,1);
         //signalHAshi2BarsAgoDown = SignalHAshi(2,2);
   
         //signalHAshiCurrentBarUp = SignalHAshi(3,0);
         signalHAshiPreviousBarUp = SignalHAshi(3,1);
         //signalHAshi2BarsAgoUp = SignalHAshi(3,2);
   
         kijunSenPreviousBarEntry = SignalKijunSen(KijenSenValueForEntry,0,1);
         kijunSenPreviousBarExit = SignalKijunSen(KijenSenValueForExit,0,1);
 
         previousPriceClose = iClose(NULL, 0, 1);
         //priceClose2BarsAgo = iClose(NULL, 0, 2);
      
         dgainUp = SignalDynamic1(0,1);
         dgainDown = SignalDynamic1(1,1);
         dgainArrowUp = SignalDynamic1(2,1);
         dgainArrowDown = SignalDynamic1(3,1);   
         ctiSignal = SignalCTI();
   
         // ----------------------- Exit Short -----------------------
         if(
               (UseKijenSenForExit == true && previousPriceClose > kijunSenPreviousBarExit)
         )
         {
            if (totalSellOrders > 0)
            {
               f_OrderClose("short",1);
               return(0);
            }
         }
         else if (UseDynamic1ForExit == true && ((dgainUp != EMPTY_VALUE && dgainUp > 0) || (dgainArrowUp != EMPTY_VALUE && dgainArrowUp > 0)))
         {
            if (totalSellOrders > 0)
            {
               f_OrderClose("short",1);
               return(0);
            }
         }
                    
         //----------------------- Exit Long -----------------------  
         if(
               (UseKijenSenForExit == true && previousPriceClose < kijunSenPreviousBarExit)
           ) 
         {
             if (totalBuyOrders > 0)
             {
               f_OrderClose("long",1);
               return(0);
             }
         }   
         else  if(
            (UseDynamic1ForExit == true && ((dgainDown != EMPTY_VALUE && dgainDown > 0) || (dgainArrowDown != EMPTY_VALUE && dgainArrowDown > 0))) 
           ) 
         {
             if (totalBuyOrders > 0)
             {
               f_OrderClose("long",1);
               return(0);
             }
         }   
          
          
        if(UseTimeFilter && !IsTradeTime()) return(0); //don't enter any trades if Time filter or News filter is in affect at current time
                      
   
         //Print("----> total orders = ", totalOrders);
         
         if (totalOrders == 0)
         { 
            bbandStopUp = SignalBBand(0,0);
            bbandUpTrendLine = SignalBBand(4,0);
         
            // ----------------------- Entry Long -----------------------
            if( 
                   (UseKijenSenForEntry == false || previousPriceClose > kijunSenPreviousBarEntry)
                && (UseHeikenCandleClosed == false || signalHAshiPreviousBarDown < signalHAshiPreviousBarUp)
                && (ctiSignal == 1) //all CTIs pointing up
                && (UseDynamic1 == false || (dgainUp != EMPTY_VALUE && dgainUp > 0) || (dgainArrowUp != EMPTY_VALUE && dgainArrowUp > 0)) 
                && (UseBBandStop == false || (bbandStopUp != EMPTY_VALUE && Bid > bbandStopUp) || (bbandUpTrendLine != EMPTY_VALUE && Bid > bbandUpTrendLine))
             )
            {
               f_OpenLong(Ask,MagicNumber+"_long",TakeProfit,StopLoss,Lots);
               //ShortActive=false;
               //LongActive=true; 
               Print ("Long Order openned!");
               CandleOpenTime =Time[0];
            }
         }
       
         if (totalOrders == 0)
         {
            bbandStopDown = SignalBBand(1,0);
            bbandDownTrendLine = SignalBBand(5,0);
            
            //----------------------- Entry Short -----------------------  
            if ( 
                     (UseKijenSenForEntry == false || previousPriceClose < kijunSenPreviousBarEntry)
                  && (UseHeikenCandleClosed == false || signalHAshiPreviousBarDown > signalHAshiPreviousBarUp)
                  && (ctiSignal == -1) //all CTIs pointing down
                  && (UseDynamic1 == false || (dgainDown != EMPTY_VALUE && dgainDown > 0) || (dgainArrowDown != EMPTY_VALUE && dgainArrowDown > 0)) //&& (UseDynamic1 == false || (dgainDown != EMPTY_VALUE && Ask < dgainDown))
                  && (UseBBandStop == false || (bbandStopDown != EMPTY_VALUE && Ask < bbandStopDown) || (bbandDownTrendLine != EMPTY_VALUE && Ask < bbandDownTrendLine))
               )
            {
               f_OpenShort(Bid,MagicNumber+"_short",TakeProfit,StopLoss,Lots);
               //ShortActive=true;
               //LongActive=false;
               Print ("Short Order openned!");
               CandleOpenTime =Time[0];
            } 
       }
    }
   
   //Trailing Stop
   if (TrailingProfit > 0 || TrailingStop > 0) MoveTrailingStop();
   if (BreakEvenAt > 0) MoveBreakEven();  

}
  
double SignalHAshi(int Mode,int Shift)
{
   //Mode 2= Open, Mode 3=Close
   double HAshi;
   HAshi =iCustom(NULL, 0, "-- Heiken_Ashi_Ma_T3",Heiken_MAPeriod,Heiken_MAMethod,Heiken_Step,Heiken_CountBars,Heiken_UseT3,Heiken_b,false,Mode,Shift);
   return (HAshi);
}

double SignalKijunSen(int value, int Mode,int Shift)
{
   double kijun;
   kijun =iCustom(NULL, 0, "Kijun-sen+",value,0,Mode,Shift);
   return (kijun);
}


int SignalCTI()
{
   int signal = 0; //0 = nothing, 1 = buy, -1 = sell
   double cti1Up, cti1Down, cti2Up, cti2Down, cti3Up, cti3Down;
   cti1Down = iCustom(NULL, 0, "Heiken_AshiH_sw_mtf",CTI_TimeFrame1,0,0,0,1);
   cti1Up = iCustom(NULL, 0, "Heiken_AshiH_sw_mtf",CTI_TimeFrame1,0,0,1,1);
   cti2Down = iCustom(NULL, 0, "Heiken_AshiH_sw_mtf",CTI_TimeFrame2,0,0,0,1);
   cti2Up = iCustom(NULL, 0, "Heiken_AshiH_sw_mtf",CTI_TimeFrame2,0,0,1,1);

   //cti3Down = iCustom(NULL, 0, "Heiken_AshiH_sw_mtf",CTI_TimeFrame3,0,0,3,1);
   //cti3Up = iCustom(NULL, 0, "Heiken_AshiH_sw_mtf",CTI_TimeFrame3,0,0,4,1);

  
   /*cti1Down = iCustom(NULL, CTI_TimeFrame1, "Heiken Ashi",0,1);
   cti1Up = iCustom(NULL, CTI_TimeFrame1, "Heiken Ashi",1,1);
   cti2Down = iCustom(NULL, CTI_TimeFrame2, "Heiken Ashi",0,1);
   cti2Up = iCustom(NULL, CTI_TimeFrame2, "Heiken Ashi",1,1);
   */
   
   if (
         (UseCTI_1 == false || cti1Down > cti1Up)
      && (UseCTI_2 == false || cti2Down > cti2Up)
     )
      signal = -1;
   else if(
        (UseCTI_1 == false || cti1Down < cti1Up)
     && (UseCTI_2 == false || cti2Down < cti2Up)
   )
      signal = 1;
   
   //Print("--> cti signal = ", signal, ". cti1down = ", cti1Down, ". cti2down = ", cti2Down);
   //Print("--> cti signal = ", signal, ". cti1up = ", cti1Up, ". cti2up = ", cti2Up);
   
   return(signal);
}


double SignalDynamic1(int Mode,int Shift)
{
   double dgain;
   dgain =iCustom(NULL, 0, "DYNAMIC GAINS 1",Dynamic_MAPeriod,Dynamic_MAMethod,Dynamic_UseSignal,0,0,233,234,Mode,Shift);
   return (dgain);
}

double SignalBBand(int Mode,int Shift)
{
   double bband;
   bband =iCustom(NULL, 0, "BBand Stop Alert",BBand_Length,BBand_Deviation,BBand_MoneyRisk,BBand_Signal,BBand_Line,BBand_NBars,false,Mode,Shift);
   return (bband);
}

void GetOrderTotals(int& totalBuyOrders, int& totalSellOrders, double& largestBuyLotSize, double& largestSellLotSize, double& lastBuyPrice, double& lastSellPrice)
{
   totalBuyOrders = 0;
   totalSellOrders = 0;
   largestBuyLotSize = 0;
   largestSellLotSize = 0;
   lastBuyPrice = 0;
   lastSellPrice = 0;
   
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber() == MagicNumber && OrderSymbol()==Symbol())
      {
         if((OrderType() == OP_BUY))
         {         
            totalBuyOrders++;
            if (OrderLots() > largestBuyLotSize)
            {
               largestBuyLotSize = OrderLots();
               lastBuyPrice = OrderOpenPrice();   
            }   
         }
         else if((OrderType() == OP_SELL))
         {
            totalSellOrders++;
            if (OrderLots() > largestSellLotSize)
            {
               largestSellLotSize = OrderLots();
               lastSellPrice = OrderOpenPrice();
            }  
         }
      }
   }  
}

void MoveBreakEven()
{
   int cnt,total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(BreakEvenAt>0)
            {
               if(NormalizeDouble((Bid-OrderOpenPrice()),digits)>BreakEvenAt*point)
               {
                  if(NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),digits)<0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+0*point,digits),OrderTakeProfit(),0,Blue);
                     return(0);
                  }
               }
            }
         }
         else
         {
            if(BreakEvenAt>0)
            {
               if(NormalizeDouble((OrderOpenPrice()-Ask),digits)>BreakEvenAt*point)
               {
                  if(NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),digits)<0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-0*point,digits),OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
}

//+------------------------------------------------------------------+
//| move StopLoss for all trades based on TrailingStop setting          |
//+------------------------------------------------------------------+  
void MoveTrailingStop()
{
   int cnt,total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(TrailingStop>0&&Ask>NormalizeDouble(OrderOpenPrice()+TrailingProfit*point,digits))  
            {                 
               if((NormalizeDouble(OrderStopLoss(),digits)<NormalizeDouble(Bid-point*(TrailingStop+TrailingStep),digits))||(OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-point*TrailingStop,digits),OrderTakeProfit(),0,Blue);
                  return(0);
               }
            }
         }
         else 
         {
            if(TrailingStop>0&&Bid<NormalizeDouble(OrderOpenPrice()-TrailingProfit*point,digits))  
            {                 
               if((NormalizeDouble(OrderStopLoss(),digits)>(NormalizeDouble(Ask+point*(TrailingStop+TrailingStep),digits)))||(OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+point*TrailingStop,digits),OrderTakeProfit(),0,Red);
                  return(0);
               }
            }
         }
      }
   }
}
 
bool IsNews()
{
    if ((TimeCurrent() > (time[4]) && UseNewsFilter)) 
    {
        news1 = iCustom(Symbol(), 0, "THV3 FFCal", IncludeHigh, IncludeMedium, IncludeLow, IncludeSpeaks, 1, 1, 1, 1);
        news2 = iCustom(Symbol(), 0, "THV3 FFCal", IncludeHigh, IncludeMedium, IncludeLow, IncludeSpeaks, 1, 1, 1, 0);
         
        if ((news1 != 99999) && (news2 != 99999)) 
        {
            time[2] = iTime(Symbol(), PERIOD_M1, 0) - 60 * (news2 - MinutesAfterNews);
            time[3] = iTime(Symbol(), PERIOD_M1, 0) + 60 * (news1 - MinutesBeforeNews);
            time[4] = iTime(Symbol(), PERIOD_M1, 0) + 60 * (news2 + MinutesAfterNews);
        }
    }
      
    bool newsStatus = (TimeCurrent() > time[2]) && (TimeCurrent() < time[3]) || (TimeCurrent() > time[4]);
 
    if (UseNewsFilter) 
    {
        if (!newsStatus)
        {
            return (1);
        }
        else if ((news1 == 99999) || (news2 == 99999))
        {
            return (0);
        }
        else
        {
            return (0);
        }
    }
}
 
 
bool IsTradeTime()
{
  int hour = TimeHour(TimeCurrent()) + GMTOffset;
  int day = DayOfWeek();
  
  if(day < StartDay || day > EndDay || (StartHour < EndHour && (hour < StartHour || hour >= EndHour)) || (StartHour > EndHour && (hour < StartHour && hour >= EndHour))) 
      return(false);
  else
     return(true);
 }                
 
void f_OpenLong(double Preis, string Typ, double TP, double SL,double Lots )
{
   Print ("HAshi EA Open Long!");
   //Preis = NormalizeDouble(Preis,digits);
   if (IsTradeAllowed())
   {
      RefreshRates();
      int ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,Typ + "_Buy",MagicNumber,0,Green);
        if(ticket<0)
          {
           Print("OrderSend buy failed with error #",GetLastError());
           return(0);
          }
          f_modify(ticket,Preis-SL*point,Ask+TP*point,Green);
   }
   Sleep(100);
}


void f_OpenShort(double Preis, string Typ,double TP, double SL,double Lots)
{
   Print ("HAshi EA Open Short!");
   Preis = NormalizeDouble(Preis,digits);
   if (IsTradeAllowed())
   {
      RefreshRates();
      int ticket=OrderSend(Symbol(),OP_SELL,Lots,Preis,3,0,0,Typ+"_Sell",MagicNumber,0,Red);
      if(ticket<0)
        {
         Print("OrderSend sell failed with error #",GetLastError());
         return(0);
        }
        f_modify(ticket,Preis+SL*point,Preis-TP*point,Red);
   }  
   Sleep(100);     
}
  
void f_modify(int Ticket,double stop, double take, color clr )
{
   Print("HAshi EA Start Order modify!");
   bool modi;
   int cnt=0;
   
   take=NormalizeDouble(take,digits);
   stop=NormalizeDouble(stop,digits);

   if (take>0)
      {
            OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES);
            modi=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),take,0,clr); 

              //Loop bis OrderModify ausgefhrt wurde!
              while (!modi&&cnt<4)
                   {
                     modi=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),take,0,clr); 
                     Sleep(100);
                     RefreshRates();
                     cnt++;
                   } 
      }  
          
   cnt=0;
 
   if (stop>0)
      {
            OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES); 
            modi=OrderModify(OrderTicket(),OrderOpenPrice(),stop,OrderTakeProfit(),0,clr); 

               while(!modi&&cnt<4)
                  { 
                     modi=OrderModify(OrderTicket(),OrderOpenPrice(),stop,OrderTakeProfit(),0,clr); 
                     Sleep(100);
                     RefreshRates();
                     cnt++;
                   }
      }
 
   if(modi==true && stop>0||take>0) Print("Order modified successfully!");
   else Print("Order modify failed!");
 
}  


  
void f_OrderClose(string Typ,double LotsPercent)
{
double LotsPart;
//double nBid = NormalizeDouble(Bid,digits);
//double nAsk = NormalizeDouble(Ask, digits);
 
   for (int i=0; i<OrdersTotal(); i++)
       {
          OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
          LotsPart = NormalizeDouble(OrderLots()*LotsPercent,2);
          if (OrderSymbol() == Symbol() && OrderMagicNumber()==MagicNumber)
          {
             if (OrderType() == OP_BUY && Typ=="long")       OrderClose(OrderTicket(),LotsPart,Bid,2,Green);
             if (OrderType() == OP_SELL&& Typ=="short")      OrderClose(OrderTicket(),LotsPart,Ask,2,Red);
             
          }
       }
} 
  
/*
void f_checkTrailing()
 {
    if (OrdersTotal()==0) return (0);
 
    for (int i = 0; i <= OrdersTotal(); i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()) 
        {
            if (Bid - OrderOpenPrice() >= TrailingStop*point)
             {
                 if (Bid - OrderStopLoss() >= (TrailingStop + TrailingStep)*point)
                  {
                     OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss() + TrailingStep*point, OrderTakeProfit(), 0);
                  }
             }  
        }
 
         if (OrderType() == OP_SELL && OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol())
         {
            if (OrderOpenPrice() - Ask >= TrailingStop*point)
            {
               if (OrderStopLoss() - Ask >= (TrailingStop + TrailingStep)*point)
                {
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss() - TrailingStep*point, OrderTakeProfit(), 0);
                }
            } 
         }   
                     
    }                         
 }
 */
 
 /*
 void f_checkBreakEven()
 {
   if (OrdersTotal()==0) return (0);
 
   if (!BreakEvenLongActive && !BreakEvenShortActive)
   {
            for (int i = 0; i <= OrdersTotal(); i++)
            {
               OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
                if (OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()) 
                {
                       if (Bid - OrderOpenPrice() >= BreakEvenStop*point)
                        {
                                BreakEvenLongPrice = OrderOpenPrice()+ MarketInfo(Symbol(),MODE_SPREAD)*point;
                                BreakEvenLongActive =true;
                        }  
                }
 
                 if (OrderType() == OP_SELL && OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol())
                 {
                      if (OrderOpenPrice() - Ask >= BreakEvenStop*point)
                       {
                         BreakEvenShortPrice = OrderOpenPrice()- MarketInfo(Symbol(),MODE_SPREAD)*point;
                         BreakEvenShortActive =true;
                       }
                 }   
            }                        
   }     
   else if (BreakEvenLongActive)
   {    
        if (Bid < BreakEvenLongPrice)
         {
                 Print("Break Even Long reached! Close Position!");
                 f_OrderClose("long",1);
                 BreakEvenLongActive =false;
         }              
   }   
   else if (BreakEvenShortActive)
   {    
        if (Ask > BreakEvenShortPrice)
         {
                 Print("Break Even Short reached! Close Position!");
                 f_OrderClose("short",1);
                 BreakEvenShortActive =false;
         }              
   }                    
}
*/

void f_PrintEAInfo()
{
   Message="\n--------------- EA Info --------------";
   Message = Message + "\nID: " + MagicNumber ;
   Message=  Message + "\n------ Money Management -----";   
   Message = Message + "\nLots: " + DoubleToStr(Lots,2) ;
   Message = Message + "\nStopLoss: " + DoubleToStr(StopLoss,2) ;
   Message = Message + "\nTakeProfit: " + DoubleToStr(TakeProfit,2) ;
   Message=  Message + "\n------------------------------------------";   
   
   if (TrailingStep > 0)
   {
      Message = Message + "\nTrailing Active!";
      Message = Message + "\nTStop: " + DoubleToStr(TrailingStop,2) ;
      Message = Message + "\nTStep: " + DoubleToStr(TrailingStep,2) ;
      Message = Message + "\nTrailing starts when we are " + DoubleToStr(TrailingProfit,2) + " pips in profit." ;
   }
   Message=  Message + "\n------------------------------------------";   
   if (BreakEvenAt > 0)
   {
      Message = Message + "\nBreak Even Active!";
      Message = Message + "\nBreak Even when we are " + DoubleToStr(BreakEvenAt,2) + " pips in profit.";

//   Message = Message + "\nBStop: " + DoubleToStr(BreakEvenStop,2) ;
//   Message = Message + "\nBStep: " + DoubleToStr(BreakEvenStep,2) ;
   }
      
   Comment(Message);
}
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }  